=== modified file 'Makefile'
--- Makefile	2010-09-10 17:06:26 +0000
+++ Makefile	2009-10-26 21:16:16 +0000
@@ -13,10 +13,9 @@
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 LINK_FORTIFY_LD=-z relro -z now
 LINK_FORTIFY=
-
-# If BROKEN_PIE is set, do not build with -pie
 ifndef BROKEN_PIE
 FORTIFY += -fPIE
+LINK_FORTIFY_LD += -fPIE
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage
@@ -57,7 +56,7 @@
 LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
-DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
+DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
 	--param man.charmap.use.subset		0 \
 	--param make.year.ranges		1 \
 	--param make.single.year.ranges		1 \
@@ -65,11 +64,11 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@))
+	$(MANPOST) $(notdir $@)
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
-DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
+DOCBOOKTOHTML=xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
 	--param make.single.year.ranges		1 \
 	--param man.output.quietly		1 \
@@ -77,7 +76,7 @@
 	--param citerefentry.link		1 \
 	--output $@ \
 	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
-	$<; $(HTMLPOST) $@)
+	$<; $(HTMLPOST) $@
 # Fix citerefentry links
 HTMLPOST=$(SED) --in-place \
 	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
@@ -158,39 +157,39 @@
 
 # Update all these files with version number $(version)
 common.ent: Makefile
-	$(strip $(SED) --in-place \
+	$(SED) --in-place \
 		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
-		$@)
+		$@
 
 mandos: Makefile
-	$(strip $(SED) --in-place \
+	$(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@)
+		$@
 
 mandos-keygen: Makefile
-	$(strip $(SED) --in-place \
+	$(SED) --in-place \
 		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
-		$@)
+		$@
 
 mandos-ctl: Makefile
-	$(strip $(SED) --in-place \
+	$(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@)
+		$@
 
 mandos.lsm: Makefile
-	$(strip $(SED) --in-place \
+	$(SED) --in-place \
 		--expression='s/^\(Version:\).*/\1\t$(version)/' \
-		$@)
-	$(strip $(SED) --in-place \
+		$@
+	$(SED) --in-place \
 		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
-		$@)
-	$(strip $(SED) --in-place \
+		$@
+	$(SED) --in-place \
 		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
-		$@)
+		$@
 
-plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(LINK.c) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) $(strip\
-		) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+plugins.d/mandos-client: plugins.d/mandos-client.o
+	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
+		$(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
 
 .PHONY : all doc html clean distclean run-client run-server install \
 	install-server install-client uninstall uninstall-server \
@@ -209,17 +208,6 @@
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
-	@echo "###################################################################"
-	@echo "# The following error messages are harmless and can be safely     #"
-	@echo "# ignored.  The messages are caused by not running as root, but   #"
-	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
-	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setuid: Operation not permitted             #"
-	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client: setuid: Operation not permitted             #"
-	@echo "#                     seteuid: Operation not permitted            #"
-	@echo "#                     klogctl: Operation not permitted            #"
-	@echo "###################################################################"
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
@@ -232,13 +220,6 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	@echo "#################################################################"
-	@echo "# NOTE: Please IGNORE errors about \"No permission to bind to    #"
-	@echo "# interface\" or \"Could not open file u'/var/run/mandos.pid'\" -  #"
-	@echo "# they are harmless and are caused by the server not running as #"
-	@echo "# root.  Do NOT run \"make run-server\" server as root if you did #"
-	@echo "# not also unpack and compile it as root.                       #"
-	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server
@@ -265,8 +246,6 @@
 		mandos.conf
 	install --mode=u=rw --target-directory=$(CONFDIR) \
 		clients.conf
-	install --mode=u=rw,go=r dbus-mandos.conf \
-		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 	install --mode=u=rwx,go=rx init.d-mandos \
 		$(DESTDIR)/etc/init.d/mandos
 	install --mode=u=rw,go=r default-mandos \
@@ -376,7 +355,6 @@
 
 purge-server: uninstall-server
 	-rm --force $(CONFDIR)/mandos.conf $(CONFDIR)/clients.conf \
-		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 		$(DESTDIR)/etc/default/mandos \
 		$(DESTDIR)/etc/init.d/mandos \
 		$(DESTDIR)/var/run/mandos.pid

=== modified file 'README'
--- README	2009-11-03 00:12:35 +0000
+++ README	2009-02-23 11:52:42 +0000
@@ -99,7 +99,7 @@
    Multiple Mandos servers can coexist on a network without any
    trouble.  They do not clash, and clients will try all available
    servers.  This means that if just one reboots then the other can
-   bring it back up, but if both reboot at the same time they will
+   bring it back up, but if both reboots at the same time they will
    stay down until someone types in the password on one of them.
 
 ** Faking ping replies?

=== modified file 'TODO'
--- TODO	2010-09-09 18:16:14 +0000
+++ TODO	2009-10-18 17:29:55 +0000
@@ -1,7 +1,5 @@
 -*- org -*-
 
-* Use _attribute_((nonnull)) wherever possible.
-
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
@@ -10,98 +8,88 @@
 *** A closed connection during the TLS handshake
 *** A TCP timeout
 ** TODO [#B] Use capabilities instead of seteuid().
-** TODO [#A] Retry --connect forever
+** TODO use EX_* from <sysexits.h>
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
+** TODO use error() instead of perror()
 
 * usplash
-** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
+** TODO use error() instead of perror()
+** TODO use EX_* from <sysexits.h>
 
 * askpass-fifo
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
+** TODO use error() instead of perror()
 ** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] use error() instead of perror()
-** TODO [#B] lock stdin (with flock()?)
+** TODO use error() instead of perror()
+** TODO lock stdin (with flock()?)
 
-* TODO [#B] passdev
+* TODO passdev
 
 * plugin-runner
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
-** kernel command line option for debug info
-** TODO [#B] use error() instead of perror()
-** TODO [#B] Use openat()
+** TODO use EX_* from <sysexits.h>
+** TODO use error() instead of perror()
 
 * mandos (server)
-** TODO [#B] Log level							  :BUGS:
-** TODO Persistent state						  :BUGS:
-   /var/lib/mandos/*
-*** TODO /etc/mandos/clients.d/*.conf
-    Watch this directory and add/remove/update clients?
-** TODO [#C] config for TXT record
-** TODO Log level option
-   syslogger.setLevel(logging.WARNING)
-   + SetLogLevel D-Bus call
-** TODO Implement --foreground						  :BUGS:
+** TODO [#B] Log level				:BUGS:
+** TODO /etc/mandos/clients.d/*.conf
+   Watch this directory and add/remove/update clients?
+** TODO config for TXT record
+** TODO [#B] Run-time communication with server :BUGS:
+   Probably using D-Bus
+*** Client class
+*** Main server
+    + SetLogLevel
+      syslogger.setLevel(logging.WARNING)
+    + [[http://log.ometer.com/2007-05.html][Best D-Bus practices]]
+** TODO Implement --foreground			:BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Date+time on console log messages				  :BUGS:
+** TODO Date+time on console log messages	:BUGS:
    Is this the default?
-** TODO [#C] DBusServiceObjectUsingSuper
-** TODO [#B] Global enable/disable flag
-** TODO [#B] By-client countdown on secrets given
-** TODO [#B] Fix problem with fsck taking a really long time
+** TODO DBusServiceObjectUsingSuper
+** TODO Global enable/disable flag
+** TODO By-client countdown on secrets given
+** TODO Fix problem with fsck taking a really long time
    Whenever a client successfully gets a secret it could get a
    one-time timeout boost to allow for an fsck-incurred delay
-** TODO [#A] Delay before client receives key
+** TODO Delay before client receives key
    This would give an operator opportunity to cancel the request if
    desired.
-** TODO [#A] Client manual approval mode
+** TODO Client manual approval mode
    A client needs manual approval on the server before it gets the
    secret
-** TODO [#B] Support RFC 3339 time duration syntax
-** More D-Bus methods
-*** NeedsApproval(50, True) -> timeout, default approve
-    Default approval is configurable, but True by default
-    + Approve(True) -> approve sending saved
-    + Approve(False) -> Close client connection immediately
-*** NeedsPassword(50) - Timeout, default disapprove
-    + SetPass(u"gazonk", True) -> Approval, persistent
-    + Approve(False) -> Close client connection immediately
-** TODO [#C] python-parsedatetime
-** TODO [#C] systemd/launchd
-   http://0pointer.de/blog/projects/systemd.html
+** TODO Persistent state
+   /var/lib/mandos/*
 
 * mandos.xml
 ** [[file:mandos.xml::XXX][Document D-Bus interface]]
-   Remove mention of lack of such interface in BUGS section
-** Add mandos contact info in manual pages
 
-* TODO [#A] Provide and install /etc/dbus-1/system.d/mandos.conf
+* Provide and install /etc/dbus-1/system.d/mandos.conf
 
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Support RFC 3339 time duration syntax
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
   arguments.
 
 * mandos-monitor
+** D-Bus main loop w/ signal receiver
 ** Urwid client data displayer
-   Better view of client data in the listing
+*** Urwid scaffolding
+*** Client Widgets
 *** Properties popup
 
 * mandos-keygen
@@ -112,9 +100,7 @@
    For testing decryption before rebooting.
 
 * Makefile
-** TODO Add "--Xlinker --as-needed"
-   http://udrepper.livejournal.com/19395.html
-** TODO [#C] Implement DEB_BUILD_OPTIONS
+** Implement DEB_BUILD_OPTIONS
    http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
 
 * Package

=== modified file 'clients.conf'
--- clients.conf	2009-12-25 23:13:47 +0000
+++ clients.conf	2009-01-08 03:54:06 +0000
@@ -2,15 +2,15 @@
 # values, so uncomment and change them if you want different ones.
 [DEFAULT]
 
-# How long until a client is disabled and not be allowed to get the
-# data this server holds.
+# How long until a client is considered invalid - that is, ineligible
+# to get the data this server holds.
 ;timeout = 1h
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
-# above "timeout" occurs, at which time the client will be disabled,
-# and any running checker killed.
+# above "timeout" occurs, at which time the client will be marked
+# invalid, and any running checker killed.
 ;interval = 5m
 
 # What command to run as "the checker".

=== removed file 'dbus-mandos.conf'
--- dbus-mandos.conf	2009-11-09 07:35:16 +0000
+++ dbus-mandos.conf	1970-01-01 00:00:00 +0000
@@ -1,18 +0,0 @@
-<!DOCTYPE busconfig PUBLIC
- "-//freedesktop//DTD D-BUS Bus Configuration 1.0//EN"
- "http://www.freedesktop.org/standards/dbus/1.0/busconfig.dtd">
-<busconfig>
-
-  <policy group="_mandos">
-    <allow own="se.bsnet.fukt.Mandos"/>
-    <allow send_destination="se.bsnet.fukt.Mandos"/>
-    <allow receive_sender="se.bsnet.fukt.Mandos"/>
-  </policy>
-  
-  <policy user="root">
-    <allow own="se.bsnet.fukt.Mandos"/>
-    <allow send_destination="se.bsnet.fukt.Mandos"/>
-    <allow receive_sender="se.bsnet.fukt.Mandos"/>
-  </policy>
-
-</busconfig>

=== modified file 'debian/control'
--- debian/control	2010-09-09 18:16:14 +0000
+++ debian/control	2009-09-17 01:21:27 +0000
@@ -15,7 +15,8 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, python-gobject, avahi-daemon, adduser
+	python-avahi, python-gobject, avahi-daemon, gnupg (< 2),
+	adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -34,8 +35,7 @@
 
 Package: mandos-client
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2)
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/rules'
--- debian/rules	2010-09-09 18:16:14 +0000
+++ debian/rules	2009-10-26 21:16:16 +0000
@@ -15,18 +15,13 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
-# -pie was broken briefly on the mips and mipsel architectures, see
-# <http://bugs.debian.org/526961>
-BINUTILS_V := $(shell dpkg-query --showformat='$${Version}' \
-			--show binutils)
-ifeq (yes,$(shell dpkg --compare-versions $(BINUTILS_V) lt 2.20-3 \
-		&& dpkg --compare-versions $(BINUTILS_V) ge 2.19.1-1 \
-		&& echo yes))
-  ifneq (,$(strip $(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:) \
-		$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:)))
-    BROKEN_PIE := yes
-    export BROKEN_PIE
-  endif
+ifneq (,$(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:))
+  BROKEN_PIE := yes
+  export BROKEN_PIE
+endif
+ifneq (,$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:))
+  BROKEN_PIE := yes
+  export BROKEN_PIE
 endif
 
 configure: configure-stamp

=== modified file 'mandos'
--- mandos	2010-09-09 18:16:14 +0000
+++ mandos	2009-10-26 21:16:16 +0000
@@ -55,12 +55,10 @@
 import logging
 import logging.handlers
 import pwd
-import contextlib
+from contextlib import closing
 import struct
 import fcntl
 import functools
-import cPickle as pickle
-import select
 
 import dbus
 import dbus.service
@@ -193,7 +191,7 @@
         self.group.Commit()
     def entry_group_state_changed(self, state, error):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi entry group state change: %i", state)
+        logger.debug(u"Avahi state change: %i", state)
         
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
             logger.debug(u"Zeroconf service established.")
@@ -212,7 +210,6 @@
             self.group = None
     def server_state_changed(self, state):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi server state change: %i", state)
         if state == avahi.SERVER_COLLISION:
             logger.error(u"Zeroconf server name collision")
             self.remove()
@@ -245,7 +242,7 @@
     enabled:    bool()
     last_checked_ok: datetime.datetime(); (UTC) or None
     timeout:    datetime.timedelta(); How long from last_checked_ok
-                                      until this client is disabled
+                                      until this client is invalid
     interval:   datetime.timedelta(); How often to start a new checker
     disable_hook:  If set, called by disable() as disable_hook(self)
     checker:    subprocess.Popen(); a running checker process used
@@ -293,9 +290,10 @@
         if u"secret" in config:
             self.secret = config[u"secret"].decode(u"base64")
         elif u"secfile" in config:
-            with open(os.path.expanduser(os.path.expandvars
-                                         (config[u"secfile"])),
-                      "rb") as secfile:
+            with closing(open(os.path.expanduser
+                              (os.path.expandvars
+                               (config[u"secfile"])),
+                              "rb")) as secfile:
                 self.secret = secfile.read()
         else:
             raise TypeError(u"No secret or secfile for client %s"
@@ -327,20 +325,19 @@
         self.checker_initiator_tag = (gobject.timeout_add
                                       (self.interval_milliseconds(),
                                        self.start_checker))
+        # Also start a new checker *right now*.
+        self.start_checker()
         # Schedule a disable() when 'timeout' has passed
         self.disable_initiator_tag = (gobject.timeout_add
                                    (self.timeout_milliseconds(),
                                     self.disable))
         self.enabled = True
-        # Also start a new checker *right now*.
-        self.start_checker()
     
-    def disable(self, quiet=True):
+    def disable(self):
         """Disable this client."""
         if not getattr(self, "enabled", False):
             return False
-        if not quiet:
-            logger.info(u"Disabling client %s", self.name)
+        logger.info(u"Disabling client %s", self.name)
         if getattr(self, u"disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
@@ -398,8 +395,8 @@
         # client would inevitably timeout, since no checker would get
         # a chance to run to completion.  If we instead leave running
         # checkers alone, the checker would have to take more time
-        # than 'timeout' for the client to be disabled, which is as it
-        # should be.
+        # than 'timeout' for the client to be declared invalid, which
+        # is as it should be.
         
         # If a checker exists, make sure it is not a zombie
         try:
@@ -470,13 +467,23 @@
         logger.debug(u"Stopping checker for %(name)s", vars(self))
         try:
             os.kill(self.checker.pid, signal.SIGTERM)
-            #time.sleep(0.5)
+            #os.sleep(0.5)
             #if self.checker.poll() is None:
             #    os.kill(self.checker.pid, signal.SIGKILL)
         except OSError, error:
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
+    
+    def still_valid(self):
+        """Has the timeout not yet passed for this client?"""
+        if not getattr(self, u"enabled", False):
+            return False
+        now = datetime.datetime.utcnow()
+        if self.last_checked_ok is None:
+            return now < (self.created + self.timeout)
+        else:
+            return now < (self.last_checked_ok + self.timeout)
 
 
 def dbus_service_property(dbus_interface, signature=u"v",
@@ -491,11 +498,6 @@
     dbus.service.method, except there is only "signature", since the
     type from Get() and the type sent to Set() is the same.
     """
-    # Encoding deeply encoded byte arrays is not supported yet by the
-    # "Set" method, so we fail early here:
-    if byte_arrays and signature != u"ay":
-        raise ValueError(u"Byte arrays not supported for non-'ay'"
-                         u" signature %r" % signature)
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -587,10 +589,6 @@
         if prop._dbus_access == u"read":
             raise DBusPropertyAccessException(property_name)
         if prop._dbus_get_args_options[u"byte_arrays"]:
-            # The byte_arrays option is not supported yet on
-            # signatures other than "ay".
-            if prop._dbus_signature != u"ay":
-                raise ValueError
             value = dbus.ByteArray(''.join(unichr(byte)
                                            for byte in value))
         prop(value)
@@ -707,10 +705,10 @@
                                        variant_level=1))
         return r
     
-    def disable(self, quiet = False):
+    def disable(self, signal = True):
         oldstate = getattr(self, u"enabled", False)
-        r = Client.disable(self, quiet=quiet)
-        if not quiet and oldstate != self.enabled:
+        r = Client.disable(self)
+        if signal and oldstate != self.enabled:
             # Emit D-Bus signal
             self.PropertyChanged(dbus.String(u"enabled"),
                                  dbus.Boolean(False, variant_level=1))
@@ -782,10 +780,13 @@
                                  dbus.Boolean(False, variant_level=1))
         return r
     
-    ## D-Bus methods, signals & properties
+    ## D-Bus methods & signals
     _interface = u"se.bsnet.fukt.Mandos.Client"
     
-    ## Signals
+    # CheckedOK - method
+    @dbus.service.method(_interface)
+    def CheckedOK(self):
+        return self.checked_ok()
     
     # CheckerCompleted - signal
     @dbus.service.signal(_interface, signature=u"nxs")
@@ -817,13 +818,6 @@
         "D-Bus signal"
         pass
     
-    ## Methods
-    
-    # CheckedOK - method
-    @dbus.service.method(_interface)
-    def CheckedOK(self):
-        return self.checked_ok()
-    
     # Enable - method
     @dbus.service.method(_interface)
     def Enable(self):
@@ -847,8 +841,6 @@
     def StopChecker(self):
         self.stop_checker()
     
-    ## Properties
-    
     # name - property
     @dbus_service_property(_interface, signature=u"s", access=u"read")
     def name_dbus_property(self):
@@ -997,17 +989,23 @@
     def handle(self):
         logger.info(u"TCP connection from: %s",
                     unicode(self.client_address))
-        logger.debug(u"IPC Pipe FD: %d",
-                     self.server.child_pipe[1].fileno())
+        logger.debug(u"IPC Pipe FD: %d", self.server.pipe[1])
         # Open IPC pipe to parent process
-        with contextlib.nested(self.server.child_pipe[1],
-                               self.server.parent_pipe[0]
-                               ) as (ipc, ipc_return):
+        with closing(os.fdopen(self.server.pipe[1], u"w", 1)) as ipc:
             session = (gnutls.connection
                        .ClientSession(self.request,
                                       gnutls.connection
                                       .X509Credentials()))
             
+            line = self.request.makefile().readline()
+            logger.debug(u"Protocol version: %r", line)
+            try:
+                if int(line.strip().split()[0]) > 1:
+                    raise RuntimeError
+            except (ValueError, IndexError, RuntimeError), error:
+                logger.error(u"Unknown protocol version: %s", error)
+                return
+            
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
             # no X.509 keys are added to it.  Therefore, we can use it
@@ -1025,18 +1023,6 @@
              .gnutls_priority_set_direct(session._c_object,
                                          priority, None))
             
-            # Start communication using the Mandos protocol
-            # Get protocol number
-            line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
-            try:
-                if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
-                return
-            
-            # Start GnuTLS connection
             try:
                 session.handshake()
             except gnutls.errors.GNUTLSError, error:
@@ -1046,56 +1032,38 @@
                 return
             logger.debug(u"Handshake succeeded")
             try:
-                try:
-                    fpr = self.fingerprint(self.peer_certificate
-                                           (session))
-                except (TypeError, gnutls.errors.GNUTLSError), error:
-                    logger.warning(u"Bad certificate: %s", error)
-                    return
-                logger.debug(u"Fingerprint: %s", fpr)
-
-                for c in self.server.clients:
-                    if c.fingerprint == fpr:
-                        client = c
-                        break
-                else:
-                    ipc.write(u"NOTFOUND %s %s\n"
-                              % (fpr, unicode(self.client_address)))
-                    return
-                
-                class ClientProxy(object):
-                    """Client proxy object.  Not for calling methods."""
-                    def __init__(self, client):
-                        self.client = client
-                    def __getattr__(self, name):
-                        if name.startswith("ipc_"):
-                            def tempfunc():
-                                ipc.write("%s %s\n" % (name[4:].upper(),
-                                                       self.client.name))
-                            return tempfunc
-                        if not hasattr(self.client, name):
-                            raise AttributeError
-                        ipc.write(u"GETATTR %s %s\n"
-                                  % (name, self.client.fingerprint))
-                        return pickle.load(ipc_return)
-                clientproxy = ClientProxy(client)
-                # Have to check if client.enabled, since it is
-                # possible that the client was disabled since the
-                # GnuTLS session was established.
-                if not clientproxy.enabled:
-                    clientproxy.ipc_disabled()
-                    return
-                
-                clientproxy.ipc_sending()
-                sent_size = 0
-                while sent_size < len(client.secret):
-                    sent = session.send(client.secret[sent_size:])
-                    logger.debug(u"Sent: %d, remaining: %d",
-                                 sent, len(client.secret)
-                                 - (sent_size + sent))
-                    sent_size += sent
-            finally:
-                session.bye()
+                fpr = self.fingerprint(self.peer_certificate(session))
+            except (TypeError, gnutls.errors.GNUTLSError), error:
+                logger.warning(u"Bad certificate: %s", error)
+                session.bye()
+                return
+            logger.debug(u"Fingerprint: %s", fpr)
+            
+            for c in self.server.clients:
+                if c.fingerprint == fpr:
+                    client = c
+                    break
+            else:
+                ipc.write(u"NOTFOUND %s %s\n"
+                          % (fpr, unicode(self.client_address)))
+                session.bye()
+                return
+            # Have to check if client.still_valid(), since it is
+            # possible that the client timed out while establishing
+            # the GnuTLS session.
+            if not client.still_valid():
+                ipc.write(u"INVALID %s\n" % client.name)
+                session.bye()
+                return
+            ipc.write(u"SENDING %s\n" % client.name)
+            sent_size = 0
+            while sent_size < len(client.secret):
+                sent = session.send(client.secret[sent_size:])
+                logger.debug(u"Sent: %d, remaining: %d",
+                             sent, len(client.secret)
+                             - (sent_size + sent))
+                sent_size += sent
+            session.bye()
     
     @staticmethod
     def peer_certificate(session):
@@ -1161,30 +1129,24 @@
         return hex_fpr
 
 
-class ForkingMixInWithPipes(socketserver.ForkingMixIn, object):
-    """Like socketserver.ForkingMixIn, but also pass a pipe pair."""
+class ForkingMixInWithPipe(socketserver.ForkingMixIn, object):
+    """Like socketserver.ForkingMixIn, but also pass a pipe."""
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
         
         This function creates a new pipe in self.pipe
         """
-        # Child writes to child_pipe
-        self.child_pipe = map(os.fdopen, os.pipe(), u"rw", (1, 0))
-        # Parent writes to parent_pipe
-        self.parent_pipe = map(os.fdopen, os.pipe(), u"rw", (1, 0))
-        super(ForkingMixInWithPipes,
+        self.pipe = os.pipe()
+        super(ForkingMixInWithPipe,
               self).process_request(request, client_address)
-        # Close unused ends for parent
-        self.parent_pipe[0].close() # close read end
-        self.child_pipe[1].close()  # close write end
-        self.add_pipe_fds(self.child_pipe[0], self.parent_pipe[1])
-    def add_pipe_fds(self, child_pipe_fd, parent_pipe_fd):
+        os.close(self.pipe[1])  # close write end
+        self.add_pipe(self.pipe[0])
+    def add_pipe(self, pipe):
         """Dummy function; override as necessary"""
-        child_pipe_fd.close()
-        parent_pipe_fd.close()
-
-
-class IPv6_TCPServer(ForkingMixInWithPipes,
+        os.close(pipe)
+
+
+class IPv6_TCPServer(ForkingMixInWithPipe,
                      socketserver.TCPServer, object):
     """IPv6-capable TCP server.  Accepts 'None' as address and/or port
     
@@ -1275,14 +1237,11 @@
             return socketserver.TCPServer.server_activate(self)
     def enable(self):
         self.enabled = True
-    def add_pipe_fds(self, child_pipe_fd, parent_pipe_fd):
+    def add_pipe(self, pipe):
         # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(child_pipe_fd.fileno(),
-                             gobject.IO_IN | gobject.IO_HUP,
-                             functools.partial(self.handle_ipc,
-                                               reply = parent_pipe_fd,
-                                               sender= child_pipe_fd))
-    def handle_ipc(self, source, condition, reply=None, sender=None):
+        gobject.io_add_watch(pipe, gobject.IO_IN | gobject.IO_HUP,
+                             self.handle_ipc)
+    def handle_ipc(self, source, condition, file_objects={}):
         condition_names = {
             gobject.IO_IN: u"IN",   # There is data to read.
             gobject.IO_OUT: u"OUT", # Data can be written (without
@@ -1300,12 +1259,16 @@
         logger.debug(u"Handling IPC: FD = %d, condition = %s", source,
                      conditions_string)
         
+        # Turn the pipe file descriptor into a Python file object
+        if source not in file_objects:
+            file_objects[source] = os.fdopen(source, u"r", 1)
+        
         # Read a line from the file object
-        cmdline = sender.readline()
+        cmdline = file_objects[source].readline()
         if not cmdline:             # Empty line means end of file
-            # close the IPC pipes
-            sender.close()
-            reply.close()
+            # close the IPC pipe
+            file_objects[source].close()
+            del file_objects[source]
             
             # Stop calling this function
             return False
@@ -1316,22 +1279,21 @@
         cmd, args = cmdline.rstrip(u"\r\n").split(None, 1)
         
         if cmd == u"NOTFOUND":
-            fpr, address = args.split(None, 1)
-            logger.warning(u"Client not found for fingerprint: %s, ad"
-                           u"dress: %s", fpr, address)
+            logger.warning(u"Client not found for fingerprint: %s",
+                           args)
             if self.use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientNotFound(fpr, address)
-        elif cmd == u"DISABLED":
+                mandos_dbus_service.ClientNotFound(args)
+        elif cmd == u"INVALID":
             for client in self.clients:
                 if client.name == args:
-                    logger.warning(u"Client %s is disabled", args)
+                    logger.warning(u"Client %s is invalid", args)
                     if self.use_dbus:
                         # Emit D-Bus signal
                         client.Rejected()
                     break
             else:
-                logger.error(u"Unknown client %s is disabled", args)
+                logger.error(u"Unknown client %s is invalid", args)
         elif cmd == u"SENDING":
             for client in self.clients:
                 if client.name == args:
@@ -1344,19 +1306,6 @@
             else:
                 logger.error(u"Sending secret to unknown client %s",
                              args)
-        elif cmd == u"GETATTR":
-            attr_name, fpr = args.split(None, 1)
-            for client in self.clients:
-                if client.fingerprint == fpr:
-                    attr_value = getattr(client, attr_name, None)
-                    logger.debug("IPC reply: %r", attr_value)
-                    pickle.dump(attr_value, reply)
-                    break
-            else:
-                logger.error(u"Client %s on address %s requesting "
-                             u"attribute %s not found", fpr, address,
-                             attr_name)
-                pickle.dump(None, reply)
         else:
             logger.error(u"Unknown IPC command: %r", cmdline)
         
@@ -1396,9 +1345,9 @@
             elif suffix == u"w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError(u"Unknown suffix %r" % suffix)
-        except (ValueError, IndexError), e:
-            raise ValueError(e.message)
+                raise ValueError
+        except (ValueError, IndexError):
+            raise ValueError
         timevalue += delta
     return timevalue
 
@@ -1417,7 +1366,7 @@
         def if_nametoindex(interface):
             "Get an interface index the hard way, i.e. using fcntl()"
             SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with contextlib.closing(socket.socket()) as s:
+            with closing(socket.socket()) as s:
                 ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
                                     struct.pack(str(u"16s16x"),
                                                 interface))
@@ -1565,8 +1514,7 @@
     tcp_server = MandosServer((server_settings[u"address"],
                                server_settings[u"port"]),
                               ClientHandler,
-                              interface=(server_settings[u"interface"]
-                                         or None),
+                              interface=server_settings[u"interface"],
                               use_ipv6=use_ipv6,
                               gnutls_priority=
                               server_settings[u"priority"],
@@ -1618,14 +1566,7 @@
     bus = dbus.SystemBus()
     # End of Avahi example code
     if use_dbus:
-        try:
-            bus_name = dbus.service.BusName(u"se.bsnet.fukt.Mandos",
-                                            bus, do_not_queue=True)
-        except dbus.exceptions.NameExistsException, e:
-            logger.error(unicode(e) + u", disabling D-Bus")
-            use_dbus = False
-            server_settings[u"use_dbus"] = False
-            tcp_server.use_dbus = False
+        bus_name = dbus.service.BusName(u"se.bsnet.fukt.Mandos", bus)
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
     service = AvahiService(name = server_settings[u"servicename"],
                            servicetype = u"_mandos._tcp",
@@ -1657,7 +1598,7 @@
         daemon()
     
     try:
-        with pidfile:
+        with closing(pidfile):
             pid = os.getpid()
             pidfile.write(str(pid) + "\n")
         del pidfile
@@ -1669,6 +1610,17 @@
         pass
     del pidfilename
     
+    def cleanup():
+        "Cleanup function; run on exit"
+        service.cleanup()
+        
+        while tcp_server.clients:
+            client = tcp_server.clients.pop()
+            client.disable_hook = None
+            client.disable()
+    
+    atexit.register(cleanup)
+    
     if not debug:
         signal.signal(signal.SIGINT, signal.SIG_IGN)
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
@@ -1681,13 +1633,13 @@
                 dbus.service.Object.__init__(self, bus, u"/")
             _interface = u"se.bsnet.fukt.Mandos"
             
-            @dbus.service.signal(_interface, signature=u"o")
-            def ClientAdded(self, objpath):
+            @dbus.service.signal(_interface, signature=u"oa{sv}")
+            def ClientAdded(self, objpath, properties):
                 "D-Bus signal"
                 pass
             
-            @dbus.service.signal(_interface, signature=u"ss")
-            def ClientNotFound(self, fingerprint, address):
+            @dbus.service.signal(_interface, signature=u"s")
+            def ClientNotFound(self, fingerprint):
                 "D-Bus signal"
                 pass
             
@@ -1719,38 +1671,21 @@
                         tcp_server.clients.remove(c)
                         c.remove_from_connection()
                         # Don't signal anything except ClientRemoved
-                        c.disable(quiet=True)
+                        c.disable(signal=False)
                         # Emit D-Bus signal
                         self.ClientRemoved(object_path, c.name)
                         return
-                raise KeyError(object_path)
+                raise KeyError
             
             del _interface
         
         mandos_dbus_service = MandosDBusService()
     
-    def cleanup():
-        "Cleanup function; run on exit"
-        service.cleanup()
-        
-        while tcp_server.clients:
-            client = tcp_server.clients.pop()
-            if use_dbus:
-                client.remove_from_connection()
-            client.disable_hook = None
-            # Don't signal anything except ClientRemoved
-            client.disable(quiet=True)
-            if use_dbus:
-                # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
-                                                  client.name)
-    
-    atexit.register(cleanup)
-    
     for client in tcp_server.clients:
         if use_dbus:
             # Emit D-Bus signal
-            mandos_dbus_service.ClientAdded(client.dbus_object_path)
+            mandos_dbus_service.ClientAdded(client.dbus_object_path,
+                                            client.GetAll(u""))
         client.enable()
     
     tcp_server.enable()
@@ -1774,7 +1709,6 @@
             service.activate()
         except dbus.exceptions.DBusException, error:
             logger.critical(u"DBusException: %s", error)
-            cleanup()
             sys.exit(1)
         # End of Avahi example code
         
@@ -1787,15 +1721,12 @@
         main_loop.run()
     except AvahiError, error:
         logger.critical(u"AvahiError: %s", error)
-        cleanup()
         sys.exit(1)
     except KeyboardInterrupt:
         if debug:
             print >> sys.stderr
         logger.debug(u"Server received KeyboardInterrupt")
     logger.debug(u"Server exiting")
-    # Must run before the D-Bus bus name gets deregistered
-    cleanup()
 
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2009-12-25 23:13:47 +0000
+++ mandos-clients.conf.xml	2009-09-17 01:21:27 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2009-12-09">
+<!ENTITY TIMESTAMP "2009-09-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -63,8 +63,9 @@
       ><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>, read by it at startup.
       The file needs to list all clients that should be able to use
-      the service.  All clients listed will be regarded as enabled,
-      even if a client was disabled in a previous run of the server.
+      the service.  All clients listed will be regarded as valid, even
+      if a client was declared invalid in a previous run of the
+      server.
     </para>
     <para>
       The format starts with a <literal>[<replaceable>section
@@ -109,8 +110,9 @@
 	  <para>
 	    The timeout is how long the server will wait (for either a
 	    successful checker run or a client receiving its secret)
-	    until a client is disabled and not allowed to get the data
-	    this server holds.  By default Mandos will use 1 hour.
+	    until a client is considered invalid - that is, ineligible
+	    to get the data this server holds.  By default Mandos will
+	    use 1 hour.
 	  </para>
 	  <para>
 	    The <replaceable>TIME</replaceable> is specified as a
@@ -141,8 +143,8 @@
 	    not be started if an old one is still running.  The server
 	    will wait for a checker to complete until the above
 	    <quote><varname>timeout</varname></quote> occurs, at which
-	    time the client will be disabled, and any running checker
-	    killed.  The default interval is 5 minutes.
+	    time the client will be marked invalid, and any running
+	    checker killed.  The default interval is 5 minutes.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-09-09 18:16:14 +0000
+++ mandos-ctl	2009-10-26 21:16:16 +0000
@@ -24,7 +24,8 @@
     'last_enabled': u'Last Enabled',
     'checker': u'Checker',
     }
-defaultkeywords = ('name', 'enabled', 'timeout', 'last_checked_ok')
+defaultkeywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
+                   'checker')
 domain = 'se.bsnet.fukt'
 busname = domain + '.Mandos'
 server_path = '/'
@@ -127,8 +128,8 @@
                   help="Start checker for client")
 parser.add_option("--stop-checker", action="store_true",
                   help="Stop checker for client")
-parser.add_option("-V", "--is-enabled", action="store_true",
-                  help="Check if client is enabled")
+parser.add_option("-V", "--is-valid", action="store_true",
+                  help="Check if client is still valid")
 parser.add_option("-r", "--remove", action="store_true",
                   help="Remove client")
 parser.add_option("-c", "--checker", type="string",
@@ -177,7 +178,7 @@
         client.StartChecker(dbus_interface=client_interface)
     if options.stop_checker:
         client.StopChecker(dbus_interface=client_interface)
-    if options.is_enabled:
+    if options.is_valid:
         sys.exit(0 if client.Get(client_interface,
                                  u"enabled",
                                  dbus_interface=dbus.PROPERTIES_IFACE)

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-09-09 18:16:14 +0000
+++ mandos-keygen	2009-10-26 21:16:16 +0000
@@ -278,7 +278,7 @@
     
     # Get fingerprint of key
     FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
+	--enable-dsa2 --homedir '"'$RINGDIR'"' --trust-model always \
 	--fingerprint --with-colons \
 	| sed --quiet \
 	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"

=== removed file 'mandos-monitor'
--- mandos-monitor	2010-09-05 20:19:02 +0000
+++ mandos-monitor	1970-01-01 00:00:00 +0000
@@ -1,636 +0,0 @@
-#!/usr/bin/python
-# -*- mode: python; coding: utf-8 -*-
-
-from __future__ import division, absolute_import, with_statement
-
-import sys
-import os
-import signal
-
-import datetime
-
-import urwid.curses_display
-import urwid
-
-from dbus.mainloop.glib import DBusGMainLoop
-import gobject
-
-import dbus
-
-import UserList
-
-import locale
-
-locale.setlocale(locale.LC_ALL, u'')
-
-# Some useful constants
-domain = 'se.bsnet.fukt'
-server_interface = domain + '.Mandos'
-client_interface = domain + '.Mandos.Client'
-version = "1.0.14"
-
-# Always run in monochrome mode
-urwid.curses_display.curses.has_colors = lambda : False
-
-# Urwid doesn't support blinking, but we want it.  Since we have no
-# use for underline on its own, we make underline also always blink.
-urwid.curses_display.curses.A_UNDERLINE |= (
-    urwid.curses_display.curses.A_BLINK)
-
-def isoformat_to_datetime(iso):
-    "Parse an ISO 8601 date string to a datetime.datetime()"
-    if not iso:
-        return None
-    d, t = iso.split(u"T", 1)
-    year, month, day = d.split(u"-", 2)
-    hour, minute, second = t.split(u":", 2)
-    second, fraction = divmod(float(second), 1)
-    return datetime.datetime(int(year),
-                             int(month),
-                             int(day),
-                             int(hour),
-                             int(minute),
-                             int(second),           # Whole seconds
-                             int(fraction*1000000)) # Microseconds
-
-class MandosClientPropertyCache(object):
-    """This wraps a Mandos Client D-Bus proxy object, caches the
-    properties and calls a hook function when any of them are
-    changed.
-    """
-    def __init__(self, proxy_object=None, *args, **kwargs):
-        self.proxy = proxy_object # Mandos Client proxy object
-        
-        self.properties = dict()
-        self.proxy.connect_to_signal(u"PropertyChanged",
-                                     self.property_changed,
-                                     client_interface,
-                                     byte_arrays=True)
-        
-        self.properties.update(
-            self.proxy.GetAll(client_interface,
-                              dbus_interface = dbus.PROPERTIES_IFACE))
-        super(MandosClientPropertyCache, self).__init__(
-            proxy_object=proxy_object, *args, **kwargs)
-    
-    def property_changed(self, property=None, value=None):
-        """This is called whenever we get a PropertyChanged signal
-        It updates the changed property in the "properties" dict.
-        """
-        # Update properties dict with new value
-        self.properties[property] = value
-
-
-class MandosClientWidget(urwid.FlowWidget, MandosClientPropertyCache):
-    """A Mandos Client which is visible on the screen.
-    """
-    
-    def __init__(self, server_proxy_object=None, update_hook=None,
-                 delete_hook=None, logger=None, *args, **kwargs):
-        # Called on update
-        self.update_hook = update_hook
-        # Called on delete
-        self.delete_hook = delete_hook
-        # Mandos Server proxy object
-        self.server_proxy_object = server_proxy_object
-        # Logger
-        self.logger = logger
-        
-        self._update_timer_callback_tag = None
-        self.last_checker_failed = False
-        
-        # The widget shown normally
-        self._text_widget = urwid.Text(u"")
-        # The widget shown when we have focus
-        self._focus_text_widget = urwid.Text(u"")
-        super(MandosClientWidget, self).__init__(
-            update_hook=update_hook, delete_hook=delete_hook,
-            *args, **kwargs)
-        self.update()
-        self.opened = False
-        self.proxy.connect_to_signal(u"CheckerCompleted",
-                                     self.checker_completed,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"CheckerStarted",
-                                     self.checker_started,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"GotSecret",
-                                     self.got_secret,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"Rejected",
-                                     self.rejected,
-                                     client_interface,
-                                     byte_arrays=True)
-        last_checked_ok = isoformat_to_datetime(self.properties
-                                                ["last_checked_ok"])
-        if last_checked_ok is None:
-            self.last_checker_failed = True
-        else:
-            self.last_checker_failed = ((datetime.datetime.utcnow()
-                                         - last_checked_ok)
-                                        > datetime.timedelta
-                                        (milliseconds=
-                                         self.properties["interval"]))
-        if self.last_checker_failed:
-            self._update_timer_callback_tag = (gobject.timeout_add
-                                               (1000,
-                                                self.update_timer))
-    
-    def checker_completed(self, exitstatus, condition, command):
-        if exitstatus == 0:
-            if self.last_checker_failed:
-                self.last_checker_failed = False
-                gobject.source_remove(self._update_timer_callback_tag)
-                self._update_timer_callback_tag = None
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' was successful'
-                        % (self.properties[u"name"], command))
-            self.update()
-            return
-        # Checker failed
-        if not self.last_checker_failed:
-            self.last_checker_failed = True
-            self._update_timer_callback_tag = (gobject.timeout_add
-                                               (1000,
-                                                self.update_timer))
-        if os.WIFEXITED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' failed with exit code %s'
-                        % (self.properties[u"name"], command,
-                           os.WEXITSTATUS(condition)))
-        elif os.WIFSIGNALED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' was killed by signal %s'
-                        % (self.properties[u"name"], command,
-                           os.WTERMSIG(condition)))
-        elif os.WCOREDUMP(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' dumped core'
-                        % (self.properties[u"name"], command))
-        else:
-            self.logger(u'Checker for client %s completed mysteriously')
-        self.update()
-    
-    def checker_started(self, command):
-        self.logger(u'Client %s started checker "%s"'
-                    % (self.properties[u"name"], unicode(command)))
-    
-    def got_secret(self):
-        self.logger(u'Client %s received its secret'
-                    % self.properties[u"name"])
-    
-    def rejected(self):
-        self.logger(u'Client %s was rejected'
-                    % self.properties[u"name"])
-    
-    def selectable(self):
-        """Make this a "selectable" widget.
-        This overrides the method from urwid.FlowWidget."""
-        return True
-    
-    def rows(self, (maxcol,), focus=False):
-        """How many rows this widget will occupy might depend on
-        whether we have focus or not.
-        This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).rows((maxcol,), focus=focus)
-    
-    def current_widget(self, focus=False):
-        if focus or self.opened:
-            return self._focus_widget
-        return self._widget
-    
-    def update(self):
-        "Called when what is visible on the screen should be updated."
-        # How to add standout mode to a style
-        with_standout = { u"normal": u"standout",
-                          u"bold": u"bold-standout",
-                          u"underline-blink":
-                              u"underline-blink-standout",
-                          u"bold-underline-blink":
-                              u"bold-underline-blink-standout",
-                          }
-        
-        # Rebuild focus and non-focus widgets using current properties
-        self._text = (u'%(name)s: %(enabled)s%(timer)s'
-                      % { u"name": self.properties[u"name"],
-                          u"enabled":
-                              (u"enabled"
-                               if self.properties[u"enabled"]
-                               else u"DISABLED"),
-                          u"timer": (unicode(datetime.timedelta
-                                             (milliseconds =
-                                              self.properties
-                                              [u"timeout"])
-                                             - (datetime.datetime
-                                                .utcnow()
-                                                - isoformat_to_datetime
-                                                (max((self.properties
-                                                 ["last_checked_ok"]
-                                                 or
-                                                 self.properties
-                                                 ["created"]),
-                                                    self.properties[u"last_enabled"]))))
-                                     if (self.last_checker_failed
-                                         and self.properties
-                                         [u"enabled"])
-                                     else u"")})
-        if not urwid.supports_unicode():
-            self._text = self._text.encode("ascii", "replace")
-        textlist = [(u"normal", self._text)]
-        self._text_widget.set_text(textlist)
-        self._focus_text_widget.set_text([(with_standout[text[0]],
-                                           text[1])
-                                          if isinstance(text, tuple)
-                                          else text
-                                          for text in textlist])
-        self._widget = self._text_widget
-        self._focus_widget = urwid.AttrWrap(self._focus_text_widget,
-                                            "standout")
-        # Run update hook, if any
-        if self.update_hook is not None:
-            self.update_hook()
-    
-    def update_timer(self):
-        "called by gobject"
-        self.update()
-        return True             # Keep calling this
-    
-    def delete(self):
-        if self._update_timer_callback_tag is not None:
-            gobject.source_remove(self._update_timer_callback_tag)
-            self._update_timer_callback_tag = None
-        if self.delete_hook is not None:
-            self.delete_hook(self)
-    
-    def render(self, (maxcol,), focus=False):
-        """Render differently if we have focus.
-        This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).render((maxcol,),
-                                                 focus=focus)
-    
-    def keypress(self, (maxcol,), key):
-        """Handle keys.
-        This overrides the method from urwid.FlowWidget"""
-        if key == u"e" or key == u"+":
-            self.proxy.Enable()
-        elif key == u"d" or key == u"-":
-            self.proxy.Disable()
-        elif key == u"r" or key == u"_" or key == u"ctrl k":
-            self.server_proxy_object.RemoveClient(self.proxy
-                                                  .object_path)
-        elif key == u"s":
-            self.proxy.StartChecker()
-        elif key == u"S":
-            self.proxy.StopChecker()
-        elif key == u"C":
-            self.proxy.CheckedOK()
-        # xxx
-#         elif key == u"p" or key == "=":
-#             self.proxy.pause()
-#         elif key == u"u" or key == ":":
-#             self.proxy.unpause()
-#         elif key == u"RET":
-#             self.open()
-        else:
-            return key
-    
-    def property_changed(self, property=None, value=None,
-                         *args, **kwargs):
-        """Call self.update() if old value is not new value.
-        This overrides the method from MandosClientPropertyCache"""
-        property_name = unicode(property)
-        old_value = self.properties.get(property_name)
-        super(MandosClientWidget, self).property_changed(
-            property=property, value=value, *args, **kwargs)
-        if self.properties.get(property_name) != old_value:
-            self.update()
-
-
-class ConstrainedListBox(urwid.ListBox):
-    """Like a normal urwid.ListBox, but will consume all "up" or
-    "down" key presses, thus not allowing any containing widgets to
-    use them as an excuse to shift focus away from this widget.
-    """
-    def keypress(self, (maxcol, maxrow), key):
-        ret = super(ConstrainedListBox, self).keypress((maxcol, maxrow), key)
-        if ret in (u"up", u"down"):
-            return
-        return ret
-
-
-class UserInterface(object):
-    """This is the entire user interface - the whole screen
-    with boxes, lists of client widgets, etc.
-    """
-    def __init__(self, max_log_length=1000):
-        DBusGMainLoop(set_as_default=True)
-        
-        self.screen = urwid.curses_display.Screen()
-        
-        self.screen.register_palette((
-                (u"normal",
-                 u"default", u"default", None),
-                (u"bold",
-                 u"default", u"default", u"bold"),
-                (u"underline-blink",
-                 u"default", u"default", u"underline"),
-                (u"standout",
-                 u"default", u"default", u"standout"),
-                (u"bold-underline-blink",
-                 u"default", u"default", (u"bold", u"underline")),
-                (u"bold-standout",
-                 u"default", u"default", (u"bold", u"standout")),
-                (u"underline-blink-standout",
-                 u"default", u"default", (u"underline", u"standout")),
-                (u"bold-underline-blink-standout",
-                 u"default", u"default", (u"bold", u"underline",
-                                          u"standout")),
-                ))
-        
-        if urwid.supports_unicode():
-            self.divider = u"─" # \u2500
-            #self.divider = u"━" # \u2501
-        else:
-            #self.divider = u"-" # \u002d
-            self.divider = u"_" # \u005f
-        
-        self.screen.start()
-        
-        self.size = self.screen.get_cols_rows()
-        
-        self.clients = urwid.SimpleListWalker([])
-        self.clients_dict = {}
-        
-        # We will add Text widgets to this list
-        self.log = []
-        self.max_log_length = max_log_length
-        
-        # We keep a reference to the log widget so we can remove it
-        # from the ListWalker without it getting destroyed
-        self.logbox = ConstrainedListBox(self.log)
-        
-        # This keeps track of whether self.uilist currently has
-        # self.logbox in it or not
-        self.log_visible = True
-        self.log_wrap = u"any"
-        
-        self.rebuild()
-        self.log_message_raw((u"bold",
-                              u"Mandos Monitor version " + version))
-        self.log_message_raw((u"bold",
-                              u"q: Quit  ?: Help"))
-        
-        self.busname = domain + '.Mandos'
-        self.main_loop = gobject.MainLoop()
-        self.bus = dbus.SystemBus()
-        mandos_dbus_objc = self.bus.get_object(
-            self.busname, u"/", follow_name_owner_changes=True)
-        self.mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                          dbus_interface
-                                          = server_interface)
-        try:
-            mandos_clients = (self.mandos_serv
-                              .GetAllClientsWithProperties())
-        except dbus.exceptions.DBusException:
-            mandos_clients = dbus.Dictionary()
-        
-        (self.mandos_serv
-         .connect_to_signal(u"ClientRemoved",
-                            self.find_and_remove_client,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        (self.mandos_serv
-         .connect_to_signal(u"ClientAdded",
-                            self.add_new_client,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        (self.mandos_serv
-         .connect_to_signal(u"ClientNotFound",
-                            self.client_not_found,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        for path, client in mandos_clients.iteritems():
-            client_proxy_object = self.bus.get_object(self.busname,
-                                                      path)
-            self.add_client(MandosClientWidget(server_proxy_object
-                                               =self.mandos_serv,
-                                               proxy_object
-                                               =client_proxy_object,
-                                               properties=client,
-                                               update_hook
-                                               =self.refresh,
-                                               delete_hook
-                                               =self.remove_client,
-                                               logger
-                                               =self.log_message),
-                            path=path)
-    
-    def client_not_found(self, fingerprint, address):
-        self.log_message((u"Client with address %s and fingerprint %s"
-                          u" could not be found" % (address,
-                                                    fingerprint)))
-    
-    def rebuild(self):
-        """This rebuilds the User Interface.
-        Call this when the widget layout needs to change"""
-        self.uilist = []
-        #self.uilist.append(urwid.ListBox(self.clients))
-        self.uilist.append(urwid.Frame(ConstrainedListBox(self.clients),
-                                       #header=urwid.Divider(),
-                                       header=None,
-                                       footer=urwid.Divider(div_char=self.divider)))
-        if self.log_visible:
-            self.uilist.append(self.logbox)
-            pass
-        self.topwidget = urwid.Pile(self.uilist)
-    
-    def log_message(self, message):
-        timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw(timestamp + u": " + message)
-    
-    def log_message_raw(self, markup):
-        """Add a log message to the log buffer."""
-        self.log.append(urwid.Text(markup, wrap=self.log_wrap))
-        if (self.max_log_length
-            and len(self.log) > self.max_log_length):
-            del self.log[0:len(self.log)-self.max_log_length-1]
-        self.logbox.set_focus(len(self.logbox.body.contents),
-                              coming_from=u"above")
-        self.refresh()
-    
-    def toggle_log_display(self):
-        """Toggle visibility of the log buffer."""
-        self.log_visible = not self.log_visible
-        self.rebuild()
-        self.log_message(u"Log visibility changed to: "
-                         + unicode(self.log_visible))
-    
-    def change_log_display(self):
-        """Change type of log display.
-        Currently, this toggles wrapping of text lines."""
-        if self.log_wrap == u"clip":
-            self.log_wrap = u"any"
-        else:
-            self.log_wrap = u"clip"
-        for textwidget in self.log:
-            textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message(u"Wrap mode: " + self.log_wrap)
-    
-    def find_and_remove_client(self, path, name):
-        """Find an client from its object path and remove it.
-        
-        This is connected to the ClientRemoved signal from the
-        Mandos server object."""
-        try:
-            client = self.clients_dict[path]
-        except KeyError:
-            # not found?
-            return
-        self.remove_client(client, path)
-    
-    def add_new_client(self, path):
-        client_proxy_object = self.bus.get_object(self.busname, path)
-        self.add_client(MandosClientWidget(server_proxy_object
-                                           =self.mandos_serv,
-                                           proxy_object
-                                           =client_proxy_object,
-                                           update_hook
-                                           =self.refresh,
-                                           delete_hook
-                                           =self.remove_client,
-                                           logger
-                                           =self.log_message),
-                        path=path)
-    
-    def add_client(self, client, path=None):
-        self.clients.append(client)
-        if path is None:
-            path = client.proxy.object_path
-        self.clients_dict[path] = client
-        self.clients.sort(None, lambda c: c.properties[u"name"])
-        self.refresh()
-    
-    def remove_client(self, client, path=None):
-        self.clients.remove(client)
-        if path is None:
-            path = client.proxy.object_path
-        del self.clients_dict[path]
-        if not self.clients_dict:
-            # Work around bug in Urwid 0.9.8.3 - if a SimpleListWalker
-            # is completely emptied, we need to recreate it.
-            self.clients = urwid.SimpleListWalker([])
-            self.rebuild()
-        self.refresh()
-    
-    def refresh(self):
-        """Redraw the screen"""
-        canvas = self.topwidget.render(self.size, focus=True)
-        self.screen.draw_screen(self.size, canvas)
-    
-    def run(self):
-        """Start the main loop and exit when it's done."""
-        self.refresh()
-        self._input_callback_tag = (gobject.io_add_watch
-                                    (sys.stdin.fileno(),
-                                     gobject.IO_IN,
-                                     self.process_input))
-        self.main_loop.run()
-        # Main loop has finished, we should close everything now
-        gobject.source_remove(self._input_callback_tag)
-        self.screen.stop()
-    
-    def stop(self):
-        self.main_loop.quit()
-    
-    def process_input(self, source, condition):
-        keys = self.screen.get_input()
-        translations = { u"ctrl n": u"down",      # Emacs
-                         u"ctrl p": u"up",        # Emacs
-                         u"ctrl v": u"page down", # Emacs
-                         u"meta v": u"page up",   # Emacs
-                         u" ": u"page down",      # less
-                         u"f": u"page down",      # less
-                         u"b": u"page up",        # less
-                         u"j": u"down",           # vi
-                         u"k": u"up",             # vi
-                         }
-        for key in keys:
-            try:
-                key = translations[key]
-            except KeyError:    # :-)
-                pass
-            
-            if key == u"q" or key == u"Q":
-                self.stop()
-                break
-            elif key == u"window resize":
-                self.size = self.screen.get_cols_rows()
-                self.refresh()
-            elif key == u"\f":  # Ctrl-L
-                self.refresh()
-            elif key == u"l" or key == u"D":
-                self.toggle_log_display()
-                self.refresh()
-            elif key == u"w" or key == u"i":
-                self.change_log_display()
-                self.refresh()
-            elif key == u"?" or key == u"f1" or key == u"esc":
-                if not self.log_visible:
-                    self.log_visible = True
-                    self.rebuild()
-                self.log_message_raw((u"bold",
-                                      u"  ".
-                                      join((u"q: Quit",
-                                            u"?: Help",
-                                            u"l: Log window toggle",
-                                            u"TAB: Switch window",
-                                            u"w: Wrap (log)"))))
-                self.log_message_raw((u"bold",
-                                      u"  "
-                                      .join((u"Clients:",
-                                             u"e: Enable",
-                                             u"d: Disable",
-                                             u"r: Remove",
-                                             u"s: Start new checker",
-                                             u"S: Stop checker",
-                                             u"C: Checker OK"))))
-                self.refresh()
-            elif key == u"tab":
-                if self.topwidget.get_focus() is self.logbox:
-                    self.topwidget.set_focus(0)
-                else:
-                    self.topwidget.set_focus(self.logbox)
-                self.refresh()
-            #elif (key == u"end" or key == u"meta >" or key == u"G"
-            #      or key == u">"):
-            #    pass            # xxx end-of-buffer
-            #elif (key == u"home" or key == u"meta <" or key == u"g"
-            #      or key == u"<"):
-            #    pass            # xxx beginning-of-buffer
-            #elif key == u"ctrl e" or key == u"$":
-            #    pass            # xxx move-end-of-line
-            #elif key == u"ctrl a" or key == u"^":
-            #    pass            # xxx move-beginning-of-line
-            #elif key == u"ctrl b" or key == u"meta (" or key == u"h":
-            #    pass            # xxx left
-            #elif key == u"ctrl f" or key == u"meta )" or key == u"l":
-            #    pass            # xxx right
-            #elif key == u"a":
-            #    pass            # scroll up log
-            #elif key == u"z":
-            #    pass            # scroll down log
-            elif self.topwidget.selectable():
-                self.topwidget.keypress(self.size, key)
-                self.refresh()
-        return True
-
-ui = UserInterface()
-try:
-    ui.run()
-except Exception, e:
-    ui.log_message(unicode(e))
-    ui.screen.stop()
-    raise

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-09 18:16:14 +0000
+++ mandos.xml	2009-09-17 01:21:27 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2009-12-09">
+<!ENTITY TIMESTAMP "2009-09-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -453,9 +453,10 @@
       backtrace.  This could be considered a feature.
     </para>
     <para>
-      Currently, if a client is disabled due to having timed out, the
-      server does not record this fact onto permanent storage.  This
-      has some security implications, see <xref linkend="clients"/>.
+      Currently, if a client is declared <quote>invalid</quote> due to
+      having timed out, the server does not record this fact onto
+      permanent storage.  This has some security implications, see
+      <xref linkend="clients"/>.
     </para>
     <para>
       There is currently no way of querying the server of the current
@@ -548,18 +549,19 @@
       </para>
       <para>
 	If a client is compromised, its downtime should be duly noted
-	by the server which would therefore disable the client.  But
-	if the server was ever restarted, it would re-read its client
-	list from its configuration file and again regard all clients
-	therein as enabled, and hence eligible to receive their
-	passwords.  Therefore, be careful when restarting servers if
-	it is suspected that a client has, in fact, been compromised
-	by parties who may now be running a fake Mandos client with
-	the keys from the non-encrypted initial <acronym>RAM</acronym>
-	image of the client host.  What should be done in that case
-	(if restarting the server program really is necessary) is to
-	stop the server program, edit the configuration file to omit
-	any suspect clients, and restart the server program.
+	by the server which would therefore declare the client
+	invalid.  But if the server was ever restarted, it would
+	re-read its client list from its configuration file and again
+	regard all clients therein as valid, and hence eligible to
+	receive their passwords.  Therefore, be careful when
+	restarting servers if it is suspected that a client has, in
+	fact, been compromised by parties who may now be running a
+	fake Mandos client with the keys from the non-encrypted
+	initial <acronym>RAM</acronym> image of the client host.  What
+	should be done in that case (if restarting the server program
+	really is necessary) is to stop the server program, edit the
+	configuration file to omit any suspect clients, and restart
+	the server program.
       </para>
       <para>
 	For more details on client-side security, see

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2010-03-27 18:39:02 +0000
+++ plugin-runner.c	2009-10-24 19:17:52 +0000
@@ -25,8 +25,8 @@
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
 				   asprintf(), O_CLOEXEC */
 #include <stddef.h>		/* size_t, NULL */
-#include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
-				   realloc() */
+#include <stdlib.h>		/* malloc(), exit(), EXIT_FAILURE,
+				   EXIT_SUCCESS, realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* perror, fileno(), fprintf(),
 				   stderr, STDOUT_FILENO */
@@ -54,7 +54,7 @@
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
 				   FD_CLOEXEC */
 #include <string.h>		/* strsep, strlen(), asprintf(),
-				   strsignal(), strcmp(), strncmp() */
+				   strsignal() */
 #include <errno.h>		/* errno */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
@@ -68,8 +68,7 @@
 				*/
 #include <errno.h>		/* errno, EBADF */
 #include <inttypes.h>		/* intmax_t, PRIdMAX, strtoimax() */
-#include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_IOERR,
-				   EX_CONFIG, EX_UNAVAILABLE, EX_OK */
+#include <sysexits.h>		/* EX_OSERR, EX_USAGE */
 
 #define BUFFER_SIZE 256
 
@@ -358,13 +357,13 @@
   ret = sigaddset(&sigchld_action.sa_mask, SIGCHLD);
   if(ret == -1){
     perror("sigaddset");
-    exitstatus = EX_OSERR;
+    exitstatus = EXIT_FAILURE;
     goto fallback;
   }
   ret = sigaction(SIGCHLD, &sigchld_action, &old_sigchld_action);
   if(ret == -1){
     perror("sigaction");
-    exitstatus = EX_OSERR;
+    exitstatus = EXIT_FAILURE;
     goto fallback;
   }
   
@@ -627,7 +626,7 @@
     custom_argv = malloc(sizeof(char*) * 2);
     if(custom_argv == NULL){
       perror("malloc");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     custom_argv[0] = argv[0];
@@ -650,7 +649,7 @@
 	new_arg = strdup(p);
 	if(new_arg == NULL){
 	  perror("strdup");
-	  exitstatus = EX_OSERR;
+	  exitstatus = EXIT_FAILURE;
 	  free(org_line);
 	  goto fallback;
 	}
@@ -660,7 +659,7 @@
 			      * ((unsigned int) custom_argc + 1));
 	if(custom_argv == NULL){
 	  perror("realloc");
-	  exitstatus = EX_OSERR;
+	  exitstatus = EXIT_FAILURE;
 	  free(org_line);
 	  goto fallback;
 	}
@@ -673,7 +672,7 @@
     } while(ret == EOF and errno == EINTR);
     if(ret == EOF){
       perror("fclose");
-      exitstatus = EX_IOERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     free(org_line);
@@ -682,7 +681,7 @@
        not affect opening plugins */
     if(errno == EMFILE or errno == ENFILE or errno == ENOMEM){
       perror("fopen");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
   }
@@ -772,7 +771,7 @@
     }
     if(dir_fd == -1){
       perror("Could not open plugin dir");
-      exitstatus = EX_UNAVAILABLE;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     
@@ -782,7 +781,7 @@
     if(ret < 0){
       perror("set_cloexec_flag");
       TEMP_FAILURE_RETRY(close(dir_fd));
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
 #endif	/* O_CLOEXEC */
@@ -791,7 +790,7 @@
     if(dir == NULL){
       perror("Could not open plugin dir");
       TEMP_FAILURE_RETRY(close(dir_fd));
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
   }
@@ -808,7 +807,7 @@
     if(dirst == NULL){
       if(errno == EBADF){
 	perror("readdir");
-	exitstatus = EX_IOERR;
+	exitstatus = EXIT_FAILURE;
 	goto fallback;
       }
       break;
@@ -844,7 +843,7 @@
       for(const char **suf = bad_suffixes; *suf != NULL; suf++){
 	size_t suf_len = strlen(*suf);
 	if((d_name_len >= suf_len)
-	   and (strcmp((dirst->d_name) + d_name_len-suf_len, *suf)
+	   and (strcmp((dirst->d_name)+d_name_len-suf_len, *suf)
 		== 0)){
 	  if(debug){
 	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
@@ -938,20 +937,20 @@
     ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
     if(ret == -1){
       perror("pipe");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     /* Ask OS to automatic close the pipe on exec */
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       perror("set_cloexec_flag");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       perror("set_cloexec_flag");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     /* Block SIGCHLD until process is safely in process list */
@@ -960,7 +959,7 @@
 					      NULL));
     if(ret < 0){
       perror("sigprocmask");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -970,7 +969,7 @@
     } while(pid == -1 and errno == EINTR);
     if(pid == -1){
       perror("fork");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     if(pid == 0){
@@ -978,18 +977,18 @@
       ret = sigaction(SIGCHLD, &old_sigchld_action, NULL);
       if(ret < 0){
 	perror("sigaction");
-	_exit(EX_OSERR);
+	_exit(EXIT_FAILURE);
       }
       ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
       if(ret < 0){
 	perror("sigprocmask");
-	_exit(EX_OSERR);
+	_exit(EXIT_FAILURE);
       }
       
       ret = dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
       if(ret == -1){
 	perror("dup2");
-	_exit(EX_OSERR);
+	_exit(EXIT_FAILURE);
       }
       
       if(dirfd(dir) < 0){
@@ -1000,12 +999,12 @@
       if(p->environ[0] == NULL){
 	if(execv(filename, p->argv) < 0){
 	  perror("execv");
-	  _exit(EX_OSERR);
+	  _exit(EXIT_FAILURE);
 	}
       } else {
 	if(execve(filename, p->argv, p->environ) < 0){
 	  perror("execve");
-	  _exit(EX_OSERR);
+	  _exit(EXIT_FAILURE);
 	}
       }
       /* no return */
@@ -1023,7 +1022,7 @@
       if(ret < 0){
         perror("sigprocmask");
       }
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     
@@ -1037,7 +1036,7 @@
 					      NULL));
     if(ret < 0){
       perror("sigprocmask");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     
@@ -1070,7 +1069,7 @@
     int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
     if(select_ret == -1 and errno != EINTR){
       perror("select");
-      exitstatus = EX_OSERR;
+      exitstatus = EXIT_FAILURE;
       goto fallback;
     }
     /* OK, now either a process completed, or something can be read
@@ -1112,7 +1111,7 @@
 					 NULL));
 	  if(ret < 0){
 	    perror("sigprocmask");
-	    exitstatus = EX_OSERR;
+	    exitstatus = EXIT_FAILURE;
 	    goto fallback;
 	  }
 	  
@@ -1126,7 +1125,7 @@
 				   &sigchld_action.sa_mask, NULL)));
 	  if(ret < 0){
 	    perror("sigprocmask");
-	    exitstatus = EX_OSERR;
+	    exitstatus = EXIT_FAILURE;
 	    goto fallback;
 	  }
 	  
@@ -1143,7 +1142,7 @@
 				       proc->buffer_length);
 	if(not bret){
 	  perror("print_out_password");
-	  exitstatus = EX_IOERR;
+	  exitstatus = EXIT_FAILURE;
 	}
 	goto fallback;
       }
@@ -1162,7 +1161,7 @@
 			       + (size_t) BUFFER_SIZE);
 	if(proc->buffer == NULL){
 	  perror("malloc");
-	  exitstatus = EX_OSERR;
+	  exitstatus = EXIT_FAILURE;
 	  goto fallback;
 	}
 	proc->buffer_size += BUFFER_SIZE;
@@ -1189,8 +1188,7 @@
   
  fallback:
   
-  if(plugin_list == NULL or (exitstatus != EXIT_SUCCESS
-			     and exitstatus != EX_OK)){
+  if(plugin_list == NULL or exitstatus != EXIT_SUCCESS){
     /* Fallback if all plugins failed, none are found or an error
        occured */
     bool bret;
@@ -1205,7 +1203,7 @@
     bret = print_out_password(passwordbuffer, len);
     if(not bret){
       perror("print_out_password");
-      exitstatus = EX_IOERR;
+      exitstatus = EXIT_FAILURE;
     }
   }
   
@@ -1213,7 +1211,7 @@
   ret = sigaction(SIGCHLD, &old_sigchld_action, NULL);
   if(ret == -1){
     perror("sigaction");
-    exitstatus = EX_OSERR;
+    exitstatus = EXIT_FAILURE;
   }
   
   if(custom_argv != NULL){

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-09 18:16:14 +0000
+++ plugins.d/mandos-client.c	2009-10-24 19:17:52 +0000
@@ -43,8 +43,8 @@
 				   stdout, ferror(), remove() */
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
-				   strtof(), abort() */
+#include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
+				   srand(), strtof(), abort() */
 #include <stdbool.h>		/* bool, false, true */
 #include <string.h>		/* memset(), strcmp(), strlen(),
 				   strerror(), asprintf(), strcpy() */
@@ -82,8 +82,7 @@
 #include <signal.h>		/* sigemptyset(), sigaddset(),
 				   sigaction(), SIGTERM, sig_atomic_t,
 				   raise() */
-#include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
-				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
+#include <sysexits.h>		/* EX_OSERR, EX_USAGE */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -127,8 +126,6 @@
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
-static const char sys_class_net[] = "/sys/class/net";
-char *connect_to = NULL;
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
@@ -556,10 +553,7 @@
   gnutls_session_t session;
   int pf;			/* Protocol family */
   
-  errno = 0;
-  
   if(quit_now){
-    errno = EINTR;
     return -1;
   }
   
@@ -572,7 +566,6 @@
     break;
   default:
     fprintf(stderr, "Bad address family: %d\n", af);
-    errno = EINVAL;
     return -1;
   }
   
@@ -588,14 +581,11 @@
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
   if(tcp_sd < 0){
-    int e = errno;
     perror("socket");
-    errno = e;
     goto mandos_end;
   }
   
   if(quit_now){
-    errno = EINTR;
     goto mandos_end;
   }
   
@@ -608,15 +598,11 @@
     ret = inet_pton(af, ip, &to.in.sin_addr);
   }
   if(ret < 0 ){
-    int e = errno;
     perror("inet_pton");
-    errno = e;
     goto mandos_end;
   }
   if(ret == 0){
-    int e = errno;
     fprintf(stderr, "Bad address: %s\n", ip);
-    errno = e;
     goto mandos_end;
   }
   if(af == AF_INET6){
@@ -630,7 +616,6 @@
       if(if_index == AVAHI_IF_UNSPEC){
 	fprintf(stderr, "An IPv6 link-local address is incomplete"
 		" without a network interface\n");
-	errno = EINVAL;
 	goto mandos_end;
       }
       /* Set the network interface number as scope */
@@ -643,7 +628,6 @@
   }
   
   if(quit_now){
-    errno = EINTR;
     goto mandos_end;
   }
   
@@ -680,7 +664,6 @@
   }
   
   if(quit_now){
-    errno = EINTR;
     goto mandos_end;
   }
   
@@ -690,14 +673,11 @@
     ret = connect(tcp_sd, &to.in, sizeof(to)); /* IPv4 */
   }
   if(ret < 0){
-    int e = errno;
     perror("connect");
-    errno = e;
     goto mandos_end;
   }
   
   if(quit_now){
-    errno = EINTR;
     goto mandos_end;
   }
   
@@ -708,9 +688,7 @@
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
 				   out_size - written));
     if(ret == -1){
-      int e = errno;
       perror("write");
-      errno = e;
       goto mandos_end;
     }
     written += (size_t)ret;
@@ -726,7 +704,6 @@
     }
   
     if(quit_now){
-      errno = EINTR;
       goto mandos_end;
     }
   }
@@ -736,21 +713,18 @@
   }
   
   if(quit_now){
-    errno = EINTR;
     goto mandos_end;
   }
   
   gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
   
   if(quit_now){
-    errno = EINTR;
     goto mandos_end;
   }
   
   do {
     ret = gnutls_handshake(session);
     if(quit_now){
-      errno = EINTR;
       goto mandos_end;
     }
   } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
@@ -760,7 +734,6 @@
       fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
-    errno = EPROTO;
     goto mandos_end;
   }
   
@@ -774,21 +747,17 @@
   while(true){
     
     if(quit_now){
-      errno = EINTR;
       goto mandos_end;
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
 				   buffer_capacity);
     if(buffer_capacity == 0){
-      int e = errno;
       perror("incbuffer");
-      errno = e;
       goto mandos_end;
     }
     
     if(quit_now){
-      errno = EINTR;
       goto mandos_end;
     }
     
@@ -807,14 +776,12 @@
 	  ret = gnutls_handshake(session);
 	  
 	  if(quit_now){
-	    errno = EINTR;
 	    goto mandos_end;
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
 	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
-	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
@@ -822,7 +789,6 @@
 	fprintf(stderr, "Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
-	errno = EIO;
 	goto mandos_end;
       }
     } else {
@@ -835,14 +801,12 @@
   }
   
   if(quit_now){
-    errno = EINTR;
     goto mandos_end;
   }
   
   do {
     ret = gnutls_bye(session, GNUTLS_SHUT_RDWR);
     if(quit_now){
-      errno = EINTR;
       goto mandos_end;
     }
   } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
@@ -857,7 +821,6 @@
       written = 0;
       while(written < (size_t) decrypted_buffer_size){
 	if(quit_now){
-	  errno = EINTR;
 	  goto mandos_end;
 	}
 	
@@ -865,12 +828,10 @@
 			  (size_t)decrypted_buffer_size - written,
 			  stdout);
 	if(ret == 0 and ferror(stdout)){
-	  int e = errno;
 	  if(debug){
 	    fprintf(stderr, "Error writing encrypted data: %s\n",
 		    strerror(errno));
 	  }
-	  errno = e;
 	  goto mandos_end;
 	}
 	written += (size_t)ret;
@@ -882,25 +843,17 @@
   /* Shutdown procedure */
   
  mandos_end:
-  {
-    int e = errno;
-    free(decrypted_buffer);
-    free(buffer);
-    if(tcp_sd >= 0){
-      ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
-    }
-    if(ret == -1){
-      if(e == 0){
-	e = errno;
-      }
-      perror("close");
-    }
-    gnutls_deinit(session);
-    if(quit_now){
-      e = EINTR;
-      retval = -1;
-    }
-    errno = e;
+  free(decrypted_buffer);
+  free(buffer);
+  if(tcp_sd >= 0){
+    ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
+  }
+  if(ret == -1){
+    perror("close");
+  }
+  gnutls_deinit(session);
+  if(quit_now){
+    retval = -1;
   }
   return retval;
 }
@@ -1022,101 +975,6 @@
   errno = old_errno;
 }
 
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  ssize_t ssret;
-  char *flagname = NULL;
-  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
-		     if_entry->d_name);
-  if(ret < 0){
-    perror("asprintf");
-    return 0;
-  }
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
-  if(flags_fd == -1){
-    perror("open");
-    return 0;
-  }
-  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
-  /* read line from flags_fd */
-  ssize_t to_read = (sizeof(ifreq_flags)*2)+3; /* "0x1003\n" */
-  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
-  flagstring[(size_t)to_read] = '\0';
-  if(flagstring == NULL){
-    perror("malloc");
-    close(flags_fd);
-    return 0;
-  }
-  while(to_read > 0){
-    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
-					     (size_t)to_read));
-    if(ssret == -1){
-      perror("read");
-      free(flagstring);
-      close(flags_fd);
-      return 0;
-    }
-    to_read -= ssret;
-    if(ssret == 0){
-      break;
-    }
-  }
-  close(flags_fd);
-  intmax_t tmpmax;
-  char *tmp;
-  errno = 0;
-  tmpmax = strtoimax(flagstring, &tmp, 0);
-  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
-					 and not (isspace(*tmp)))
-     or tmpmax != (ifreq_flags)tmpmax){
-    if(debug){
-      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
-	      flagstring, if_entry->d_name);
-    }
-    free(flagstring);
-    return 0;
-  }
-  free(flagstring);
-  ifreq_flags flags = (ifreq_flags)tmpmax;
-  /* Reject the loopback device */
-  if(flags & IFF_LOOPBACK){
-    if(debug){
-      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
-    if(debug){
-      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 1;
-  }
-  /* Otherwise, reject non-broadcast-capable devices */
-  if(not (flags & IFF_BROADCAST)){
-    if(debug){
-      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept this device */
-  if(debug){
-    fprintf(stderr, "Interface \"%s\" is acceptable\n",
-	    if_entry->d_name);
-  }
-  return 1;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1124,12 +982,13 @@
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  const char *interface = "";
+  const char *interface = "eth0";
   struct ifreq network;
   int sd = -1;
   bool take_down_interface = false;
   uid_t uid;
   gid_t gid;
+  char *connect_to = NULL;
   char tempdir[] = "/tmp/mandosXXXXXX";
   bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
@@ -1292,31 +1151,6 @@
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-
-  if(interface[0] == '\0'){
-    struct dirent **direntries;
-    ret = scandir(sys_class_net, &direntries, good_interface,
-		  alphasort);
-    if(ret >= 1){
-      /* Pick the first good interface */
-      interface = strdup(direntries[0]->d_name);
-      if(debug){
-	fprintf(stderr, "Using interface \"%s\"\n", interface);
-      }
-      if(interface == NULL){
-	perror("malloc");
-	free(direntries);
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      free(direntries);
-    } else {
-      free(direntries);
-      fprintf(stderr, "Could not find a network interface\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
   
   /* Initialize Avahi early so avahi_simple_poll_quit() can be called
      from the signal handler */
@@ -1325,7 +1159,7 @@
   mc.simple_poll = avahi_simple_poll_new();
   if(mc.simple_poll == NULL){
     fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
-    exitcode = EX_UNAVAILABLE;
+    exitcode = EXIT_FAILURE;
     goto end;
   }
   
@@ -1333,19 +1167,19 @@
   ret = sigaddset(&sigterm_action.sa_mask, SIGINT);
   if(ret == -1){
     perror("sigaddset");
-    exitcode = EX_OSERR;
+    exitcode = EXIT_FAILURE;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGHUP);
   if(ret == -1){
     perror("sigaddset");
-    exitcode = EX_OSERR;
+    exitcode = EXIT_FAILURE;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGTERM);
   if(ret == -1){
     perror("sigaddset");
-    exitcode = EX_OSERR;
+    exitcode = EXIT_FAILURE;
     goto end;
   }
   /* Need to check if the handler is SIG_IGN before handling:
@@ -1355,49 +1189,49 @@
   ret = sigaction(SIGINT, NULL, &old_sigterm_action);
   if(ret == -1){
     perror("sigaction");
-    return EX_OSERR;
+    return EXIT_FAILURE;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &sigterm_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      exitcode = EX_OSERR;
+      exitcode = EXIT_FAILURE;
       goto end;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_sigterm_action);
   if(ret == -1){
     perror("sigaction");
-    return EX_OSERR;
+    return EXIT_FAILURE;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &sigterm_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      exitcode = EX_OSERR;
+      exitcode = EXIT_FAILURE;
       goto end;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_sigterm_action);
   if(ret == -1){
     perror("sigaction");
-    return EX_OSERR;
+    return EXIT_FAILURE;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &sigterm_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      exitcode = EX_OSERR;
+      exitcode = EXIT_FAILURE;
       goto end;
     }
   }
   
   /* If the interface is down, bring it up */
-  if(strcmp(interface, "none") != 0){
+  if(interface[0] != '\0'){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exitcode = EX_UNAVAILABLE;
+      exitcode = EXIT_FAILURE;
       goto end;
     }
     
@@ -1426,7 +1260,7 @@
     sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
     if(sd < 0){
       perror("socket");
-      exitcode = EX_OSERR;
+      exitcode = EXIT_FAILURE;
 #ifdef __linux__
       if(restore_loglevel){
 	ret = klogctl(7, NULL, 0);
@@ -1455,7 +1289,7 @@
 	}
       }
 #endif	/* __linux__ */
-      exitcode = EX_OSERR;
+      exitcode = EXIT_FAILURE;
       /* Lower privileges */
       errno = 0;
       ret = seteuid(uid);
@@ -1470,8 +1304,8 @@
       ret = ioctl(sd, SIOCSIFFLAGS, &network);
       if(ret == -1){
 	take_down_interface = false;
-	perror("ioctl SIOCSIFFLAGS +IFF_UP");
-	exitcode = EX_OSERR;
+	perror("ioctl SIOCSIFFLAGS");
+	exitcode = EXIT_FAILURE;
 #ifdef __linux__
 	if(restore_loglevel){
 	  ret = klogctl(7, NULL, 0);
@@ -1543,7 +1377,7 @@
   ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
     fprintf(stderr, "init_gnutls_global failed\n");
-    exitcode = EX_UNAVAILABLE;
+    exitcode = EXIT_FAILURE;
     goto end;
   } else {
     gnutls_initialized = true;
@@ -1566,7 +1400,7 @@
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
     fprintf(stderr, "init_gpgme failed\n");
-    exitcode = EX_UNAVAILABLE;
+    exitcode = EXIT_FAILURE;
     goto end;
   } else {
     gpgme_initialized = true;
@@ -1582,7 +1416,7 @@
     char *address = strrchr(connect_to, ':');
     if(address == NULL){
       fprintf(stderr, "No colon in address\n");
-      exitcode = EX_USAGE;
+      exitcode = EXIT_FAILURE;
       goto end;
     }
     
@@ -1596,7 +1430,7 @@
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
        or tmpmax != (uint16_t)tmpmax){
       fprintf(stderr, "Bad port number\n");
-      exitcode = EX_USAGE;
+      exitcode = EXIT_FAILURE;
       goto end;
     }
   
@@ -1621,25 +1455,7 @@
     
     ret = start_mandos_communication(address, port, if_index, af);
     if(ret < 0){
-      switch(errno){
-      case ENETUNREACH:
-      case EHOSTDOWN:
-      case EHOSTUNREACH:
-	exitcode = EX_NOHOST;
-	break;
-      case EINVAL:
-	exitcode = EX_USAGE;
-	break;
-      case EIO:
-	exitcode = EX_IOERR;
-	break;
-      case EPROTO:
-	exitcode = EX_PROTOCOL;
-	break;
-      default:
-	exitcode = EX_OSERR;
-	break;
-      }
+      exitcode = EXIT_FAILURE;
     } else {
       exitcode = EXIT_SUCCESS;
     }
@@ -1672,7 +1488,7 @@
   if(mc.server == NULL){
     fprintf(stderr, "Failed to create Avahi server: %s\n",
 	    avahi_strerror(error));
-    exitcode = EX_UNAVAILABLE;
+    exitcode = EXIT_FAILURE;
     goto end;
   }
   
@@ -1687,7 +1503,7 @@
   if(sb == NULL){
     fprintf(stderr, "Failed to create service browser: %s\n",
 	    avahi_strerror(avahi_server_errno(mc.server)));
-    exitcode = EX_UNAVAILABLE;
+    exitcode = EXIT_FAILURE;
     goto end;
   }
   
@@ -1745,7 +1561,7 @@
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS -IFF_UP");
+	  perror("ioctl SIOCSIFFLAGS");
 	}
       }
       ret = (int)TEMP_FAILURE_RETRY(close(sd));

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-08-10 19:08:24 +0000
+++ plugins.d/mandos-client.xml	2009-02-09 02:01:13 +0000
@@ -202,9 +202,8 @@
 	<listitem>
 	  <para>
 	    Network interface that will be brought up and scanned for
-	    Mandos servers to connect to.  The default is the empty
-	    string, which will automatically choose an appropriate
-	    interface.
+	    Mandos servers to connect to.  The default is
+	    <quote><literal>eth0</literal></quote>.
 	  </para>
 	  <para>
 	    If the <option>--connect</option> option is used, this
@@ -221,11 +220,10 @@
 	    by this program.
 	  </para>
 	  <para>
-	    <replaceable>NAME</replaceable> can be the string
-	    <quote><literal>none</literal></quote>; this will not use
-	    any specific interface, and will not bring up an interface
-	    on startup.  This is not recommended, and only meant for
-	    advanced users.
+	    <replaceable>NAME</replaceable> can be the empty string;
+	    this will not use any specific interface, and will not
+	    bring up an interface on startup.  This is not
+	    recommended, and only meant for advanced users.
 	  </para>
 	</listitem>
       </varlistentry>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-03-27 18:39:02 +0000
+++ plugins.d/password-prompt.c	2009-10-24 19:17:52 +0000
@@ -46,7 +46,7 @@
 				*/
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex */
+#include <string.h> 		/* strlen, rindex, strncmp, strcmp */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -258,31 +258,22 @@
       fprintf(stderr, "%s ", prefix);
     }
     {
-      const char *cryptsource = getenv("CRYPTTAB_SOURCE");
-      const char *crypttarget = getenv("CRYPTTAB_NAME");
-      /* Before cryptsetup 1.1.0~rc2 */
-      if(cryptsource == NULL){
-	cryptsource = getenv("cryptsource");
-      }
-      if(crypttarget == NULL){
-	crypttarget = getenv("crypttarget");
-      }
-      const char *const prompt1 = "Unlocking the disk";
-      const char *const prompt2 = "Enter passphrase";
+      const char *cryptsource = getenv("cryptsource");
+      const char *crypttarget = getenv("crypttarget");
+      const char *const prompt
+	= "Enter passphrase to unlock the disk";
       if(cryptsource == NULL){
 	if(crypttarget == NULL){
-	  fprintf(stderr, "%s to unlock the disk: ", prompt2);
+	  fprintf(stderr, "%s: ", prompt);
 	} else {
-	  fprintf(stderr, "%s (%s)\n%s: ", prompt1, crypttarget,
-		  prompt2);
+	  fprintf(stderr, "%s (%s): ", prompt, crypttarget);
 	}
       } else {
 	if(crypttarget == NULL){
-	  fprintf(stderr, "%s %s\n%s: ", prompt1, cryptsource,
-		  prompt2);
+	  fprintf(stderr, "%s %s: ", prompt, cryptsource);
 	} else {
-	  fprintf(stderr, "%s %s (%s)\n%s: ", prompt1, cryptsource,
-		  crypttarget, prompt2);
+	  fprintf(stderr, "%s %s (%s): ", prompt, cryptsource,
+		  crypttarget);
 	}
       }
     }

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2009-10-30 16:23:43 +0000
+++ plugins.d/password-prompt.xml	2009-01-04 21:54:55 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2009-10-30">
+<!ENTITY TIMESTAMP "2009-01-04">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -183,8 +183,8 @@
     <title>ENVIRONMENT</title>
     <variablelist>
       <varlistentry>
-	<term><envar>CRYPTTAB_SOURCE</envar></term>
-	<term><envar>CRYPTTAB_NAME</envar></term>
+	<term><envar>cryptsource</envar></term>
+	<term><envar>crypttarget</envar></term>
 	<listitem>
 	  <para>
 	    If set, these environment variables will be assumed to

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-03-27 18:39:02 +0000
+++ plugins.d/usplash.c	2009-09-17 04:16:32 +0000
@@ -47,7 +47,6 @@
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
 #include <inttypes.h>		/* intmax_t, strtoimax() */
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
-#include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
@@ -298,11 +297,9 @@
   size_t buf_len = 0;
   pid_t usplash_pid = -1;
   bool usplash_accessed = false;
-  int status = EXIT_FAILURE;	/* Default failure exit status */
   
   char *prompt = makeprompt();
   if(prompt == NULL){
-    status = EX_OSERR;
     goto failure;
   }
   
@@ -311,7 +308,6 @@
   size_t cmdline_len = 0;
   usplash_pid = find_usplash(&cmdline, &cmdline_len);
   if(usplash_pid == 0){
-    status = EX_UNAVAILABLE;
     goto failure;
   }
   
@@ -324,26 +320,22 @@
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
       perror("sigaddset");
-      status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
       perror("sigaddset");
-      status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
       perror("sigaddset");
-      status = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
 	perror("sigaction");
-	status = EX_OSERR;
       }
       goto failure;
     }
@@ -352,7 +344,6 @@
       if(ret == -1){
 	if(errno != EINTR){
 	  perror("sigaction");
-	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -361,7 +352,6 @@
     if(ret == -1){
       if(errno != EINTR){
 	perror("sigaction");
-	status = EX_OSERR;
       }
       goto failure;
     }
@@ -370,7 +360,6 @@
       if(ret == -1){
 	if(errno != EINTR){
 	  perror("sigaction");
-	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -379,7 +368,6 @@
     if(ret == -1){
       if(errno != EINTR){
 	perror("sigaction");
-	status = EX_OSERR;
       }
       goto failure;
     }
@@ -388,7 +376,6 @@
       if(ret == -1){
 	if(errno != EINTR){
 	  perror("sigaction");
-	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -400,7 +387,6 @@
   if(not usplash_write(&fifo_fd, "TIMEOUT", "0")){
     if(errno != EINTR){
       perror("usplash_write");
-      status = EX_OSERR;
     }
     goto failure;
   }
@@ -412,7 +398,6 @@
   if(not usplash_write(&fifo_fd, "INPUTQUIET", prompt)){
     if(errno != EINTR){
       perror("usplash_write");
-      status = EX_OSERR;
     }
     goto failure;
   }
@@ -430,7 +415,6 @@
   if(outfifo_fd == -1){
     if(errno != EINTR){
       perror("open");
-      status = EX_OSERR;
     }
     goto failure;
   }
@@ -449,7 +433,6 @@
       if(tmp == NULL){
 	if(errno != EINTR){
 	  perror("realloc");
-	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -461,7 +444,6 @@
     if(sret == -1){
       if(errno != EINTR){
 	perror("read");
-	status = EX_OSERR;
       }
       TEMP_FAILURE_RETRY(close(outfifo_fd));
       goto failure;
@@ -476,7 +458,6 @@
   if(ret == -1){
     if(errno != EINTR){
       perror("close");
-      status = EX_OSERR;
     }
     goto failure;
   }
@@ -489,7 +470,6 @@
   if(not usplash_write(&fifo_fd, "TIMEOUT", "15")){
     if(errno != EINTR){
       perror("usplash_write");
-      status = EX_OSERR;
     }
     goto failure;
   }
@@ -502,7 +482,6 @@
   if(ret == -1){
     if(errno != EINTR){
       perror("close");
-      status = EX_OSERR;
     }
     goto failure;
   }
@@ -516,7 +495,6 @@
       if(sret == -1){
 	if(errno != EINTR){
 	  perror("write");
-	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -545,7 +523,7 @@
   
   /* If usplash was never accessed, we can stop now */
   if(not usplash_accessed){
-    return status;
+    return EXIT_FAILURE;
   }
   
   /* Close FIFO */
@@ -577,7 +555,7 @@
       if(tmp == NULL){
 	perror("realloc");
 	free(cmdline_argv);
-	return status;
+	return EXIT_FAILURE;
       }
       cmdline_argv = tmp;
       cmdline_argv[cmdline_argc] = cmdline + position;
@@ -613,7 +591,7 @@
     ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
     if(ret == -1){
       perror("dup2");
-      _exit(EX_OSERR);
+      _exit(EXIT_FAILURE);
     }
     
     execv(usplash_name, cmdline_argv);
@@ -622,7 +600,7 @@
     }
     free(cmdline);
     free(cmdline_argv);
-    _exit(EX_OSERR);
+    _exit(EXIT_FAILURE);
   }
   free(cmdline);
   free(cmdline_argv);
@@ -660,5 +638,5 @@
     TEMP_FAILURE_RETRY(pause());
   }
   
-  return status;
+  return EXIT_FAILURE;
 }

